#ifndef LIBPV_H
#define LIBPV_H

#define PV_PATH_MAX (255)

#include <pv_types.h>

typedef struct {
	char	_data[45580];
} pv_engine_t;


/* start/stop/stuff */

extern pv_engine_t *pv_init		(int			argc,
					 char			*argv[]);

extern void	pv_finish		(pv_engine_t		*pv_engine);

extern int	pv_debuglevel		(pv_engine_t		*pv_engine,
					 int			level);


/* registration stuff */
extern uint8_t  *pv_register_uint8	(pv_engine_t		*pv_engine,
					 const char		*varname);

extern uint16_t *pv_register_uint16	(pv_engine_t		*pv_engine,
					 const char		*varname);

extern uint32_t *pv_register_uint32	(pv_engine_t		*pv_engine,
					 const char		*varname);

extern char     *pv_register_string	(pv_engine_t		*pv_engine,
					 const char		*varname);


/* string handling stuff */
extern int	pv_cmp_string		(pv_engine_t		*pv_engine,
					 const char		*pv_string,
					 char			*s2);

extern int	pv_get_string		(pv_engine_t		*pv_engine,
					 const char		*pv_string,
					 char			*dest,
					 size_t			n);

extern int	pv_set_string		(pv_engine_t		*pv_engine,
					 char			*pv_string,
					 char			*src,
					 size_t			n);

/* set-a-default */
extern int	pv_default		(pv_engine_t		*pv_engine,
					 void			*var);

/* lock-stuff */
extern void	pv_lock			(pv_engine_t		*pv_engine);
extern void	pv_unlock		(pv_engine_t		*pv_engine);
extern void	pv_flush		(pv_engine_t		*pv_engine,
					 void			*var,
					 size_t			n);

/* unkown stuff */
/* extern int	pv_stop_jvserver	(pv_engine_t		*pv_engine, */
/* 					 int			stop); */

extern int	pv_jvsocket		(pv_engine_t		*pv_engine,
					 struct jvisu_ops	*ops,
					 int			port);


#endif	/* !LIBPV_H */
