#include <errno.h>
#include <string.h>

#include <pv_types.h>

int pv_default(pv_engine_t *pv_engine_anon, void *pv_var)
{
	struct pv_engine *pv_engine = (struct pv_engine *)pv_engine_anon;
	pv_t *pv;
	int finished = 0;

	if (is_last(pv_engine->pv_list) == -1) 
		return -EINVAL;
	
	for (goto_head(&pv_engine->pv_list); !finished; goto_next(&pv_engine->pv_list)) {
		
		if (is_last(pv_engine->pv_list))
			finished=1;

		pv = (pv_t*)list_get_element_data(pv_engine->pv_list);
		if (pv_var == NULL
		    || (pv_engine->pv_map + pv->offset) == pv_var) {
			switch (pv->type) {
			case pv_type_uint8:
				*(uint8_t *) (pv_engine->pv_map + pv->offset) = *(uint8_t *) (&pv->dflt);
				break;
			case pv_type_uint16:
				*(uint16_t *)(pv_engine->pv_map + pv->offset) = *(uint16_t *)(&pv->dflt);
				break;
			case pv_type_uint32:
				*(uint32_t *)(pv_engine->pv_map + pv->offset) = *(uint32_t *)(&pv->dflt);
				break;
			case pv_type_string:
				memcpy(pv_engine->pv_map + pv->offset, (char *)pv->dflt, pv->size);
				break;
			case pv_type_undef:
				break;
			}

			if (pv_var != NULL)
				return 0;
		}
	}

	if (pv_var == NULL)
		return 0;

	return -EINVAL;;
}
