#include <string.h>

#include <pv_types.h>

int pv_cmp_string(pv_engine_t	*pv_engine_anon,
		  const char	*pv_string,
		  char		*s2)
{
	struct pv_engine *pv_engine = (struct pv_engine *)pv_engine_anon;
	pv_t *pv;
	int finished = 0;

	if (is_last(pv_engine->pv_list) == -1) 
		return INT32_MIN; 
	
	for (goto_head(&pv_engine->pv_list); !finished; goto_next(&pv_engine->pv_list)) {
		
		if (is_last(pv_engine->pv_list))
			finished=1;

		pv = (pv_t*)list_get_element_data(pv_engine->pv_list);
		if (pv_engine->pv_map + pv->offset == pv_string) {
			return strncmp(pv_string, s2, pv->size);
		}
	}

	return INT32_MIN;
}


int pv_get_string(pv_engine_t	*pv_engine_anon,
		  const char	*pv_string,
		  char		*dest,
		  size_t	n)
{
	struct pv_engine *pv_engine = (struct pv_engine *)pv_engine_anon;
	pv_t *pv;
	int finished = 0;
	int size;

	if (is_last(pv_engine->pv_list) == -1) 
		return 0;
	
	for (goto_head(&pv_engine->pv_list); !finished; goto_next(&pv_engine->pv_list)) {
		
		if (is_last(pv_engine->pv_list))
			finished=1;

		pv = (pv_t*)list_get_element_data(pv_engine->pv_list);
		if (pv_engine->pv_map + pv->offset == pv_string) {
			size = MIN(pv->size, n);
			strncpy(dest, pv_string, size);
			dest[size] = 0;
			return size;
		}
	}

	return 0;
}


int pv_set_string(pv_engine_t	*pv_engine_anon,
		  char		*pv_string,
		  char		*src,
		  size_t	n)
{
	struct pv_engine *pv_engine = (struct pv_engine *)pv_engine_anon;
	pv_t *pv;
	int finished = 0;
	int size;

	if (is_last(pv_engine->pv_list) == -1) 
		return 0;
	
	for (goto_head(&pv_engine->pv_list); !finished; goto_next(&pv_engine->pv_list)) {
		
		if (is_last(pv_engine->pv_list))
			finished=1;

		pv = (pv_t*)list_get_element_data(pv_engine->pv_list);
		if (pv_engine->pv_map + pv->offset == pv_string) {
			size = MIN(pv->size, n);
			strncpy(pv_string, src, size);
			pv_string[size] = 0;
			return size;
		}
	}

	return 0;
}
